#ifndef SUCCESSOR_H
#define SUCCESSOR_H

#include "nat.h"

class Successor : public Nat {
 public:
  // constructor
  Successor(std::shared_ptr<Nat> x);

  std::shared_ptr<Nat> plus(std::shared_ptr<Nat> y) const;

  std::shared_ptr<Nat> fibonacci() const;

  std::shared_ptr<Nat> fibonacciSuccessor() const;

  int toInt() const;

 private:
  std::shared_ptr<Nat> x;
};

#endif // SUCCESSOR_H
