#include "nat.h"
#include "successor.h"
#include "zero.h"

#include <iostream>

int main(int argc, char* argv[]) {
  std::shared_ptr<Nat> zero(new Zero());
  std::cout << "zero is " << zero->toInt() << "\n";
  std::shared_ptr<Nat> one(new Successor(zero));
  std::cout << "one is " << one->toInt() << "\n";
  std::shared_ptr<Nat> two(new Successor(one));
  std::cout << "two is " << two->toInt() << "\n";
  std::shared_ptr<Nat> three(new Successor(two));
  std::cout << "three is " << three->toInt() << "\n";
  std::shared_ptr<Nat> five = two->plus(three);
  std::cout << "five is " << five->toInt() << "\n";
  std::shared_ptr<Nat> eight = five->fibonacci();
  std::cout << "eight is " << eight->toInt() << "\n";
  std::shared_ptr<Nat> thirty_four = eight->fibonacci();
  std::cout << "thirty_four is " << thirty_four->toInt() << "\n";
  return 0;
}

