#include "zero.h"

#include "successor.h"

std::shared_ptr<Nat> Zero::plus(std::shared_ptr<Nat> y) const {
  return y;
}

std::shared_ptr<Nat> Zero::fibonacci() const {
  std::shared_ptr<Nat> zero(new Zero());
  std::shared_ptr<Nat> one(new Successor(zero));
  return one;
}

std::shared_ptr<Nat> Zero::fibonacciSuccessor() const {
  std::shared_ptr<Nat> zero(new Zero());
  std::shared_ptr<Nat> one(new Successor(zero));
  return one;
}

int Zero::toInt() const {
  return 0;
}
